﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Phone相机.Resources;
using Windows.Phone.Media.Capture;
using System.Windows.Media;
using System.IO;
using Microsoft.Xna.Framework.Media;
using Microsoft.Devices;
using System.Windows.Media.Imaging;

namespace Phone相机
{
    public partial class MainPage : PhoneApplicationPage
    {
        // 构造函数
        public MainPage()
        {
            InitializeComponent();

        }
        PhotoCaptureDevice photoCaptureDevice;
        CameraCaptureSequence cameraCaptureSequence;
        MemoryStream captureStream = new MemoryStream();
        protected async override void OnNavigatedTo(NavigationEventArgs e)
        {
            if (PhotoCaptureDevice.AvailableSensorLocations.Contains(CameraSensorLocation.Back))
            {
                var SupportedResolutions = PhotoCaptureDevice.GetAvailableCaptureResolutions(CameraSensorLocation.Back);
                photoCaptureDevice = await PhotoCaptureDevice.OpenAsync(CameraSensorLocation.Back, SupportedResolutions[0]);
            }
            else if (PhotoCaptureDevice.AvailableSensorLocations.Contains(CameraSensorLocation.Front))
            {
                var SupportedResolutions = PhotoCaptureDevice.GetAvailableCaptureResolutions(CameraSensorLocation.Front);
                photoCaptureDevice = await PhotoCaptureDevice.OpenAsync(CameraSensorLocation.Front, SupportedResolutions[0]);
            }
            else
            {
                return;
            }
            viewfinderBrush.SetSource(photoCaptureDevice);

            

            cameraCaptureSequence = photoCaptureDevice.CreateCaptureSequence(1);

            // Set camera properties.
            photoCaptureDevice.SetProperty(KnownCameraPhotoProperties.FlashMode, FlashState.On);
            photoCaptureDevice.SetProperty(KnownCameraGeneralProperties.PlayShutterSoundOnCapture, true);
            photoCaptureDevice.SetProperty(KnownCameraGeneralProperties.AutoFocusRange, AutoFocusRange.Infinity);

            cameraCaptureSequence.Frames[0].DesiredProperties[KnownCameraPhotoProperties.SceneMode] = CameraSceneMode.Portrait;

            cameraCaptureSequence.Frames[0].CaptureStream = captureStream.AsOutputStream();
            await photoCaptureDevice.PrepareCaptureSequenceAsync(cameraCaptureSequence);
            base.OnNavigatedTo(e);
        }

        public async void Capture()
        {
            await cameraCaptureSequence.StartCaptureAsync();
            var b = new BitmapImage();
            b.SetSource(captureStream);
            img1.Source = b;

        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            Capture();
        }

    }
}